class PUQTeamSlide {
    static get toolbox() {
        return {
            title: 'Team Slide',
            icon: '<i class="fas fa-users"></i>'
        };
    }
    constructor( {data}){
        this.data = data;
    }
    static get enableLineBreaks() {
        return true;
    }
    static get sanitize() {
        return {
            table: {
                b: true,
                bold: true,
                strong: true,
                i: true,
                a: true,
                s: true,
                img: true,
                small: true,
                br: true,
                mark: true,
                div: true,
                span: true,
                h1: true,
                h2: true,
                h3: true,
                h4: true,
                h5: true,
                hr: true,
                h6: true,
                ol: true,
                sup: true,
                sub: true,
                ul: true,
                li: true,
                p: true,
                table: true,
                tbody: true,
                tr: true,
                td: true,
                th: true,
            }
        };
    }
    render()
    {
        const render = document.createElement('div');

        const optionTemplates = generateOptionTemplates('PUQTeamSlide');

        $(render).append(`
<table class="form" width="100%" border="0" cellspacing="2" cellpadding="3">
    <tbody>
    <tr>
        <td  class="fieldlabel"><h1 style="color: blue;">Team Slide</h1></td>
        <td colspan="3" class="fieldarea">
            <label for="width">width: </label>
            <input type="text" name="width" class="form-control input-inline input-100" value="">
            <label for="margin_top">margin-top: </label>
            <input type="text" name="margin_top" class="form-control input-inline input-100" value="">
            <label for="margin_bottom">margin-bottom: </label>
            <input type="text" name="margin_bottom" class="form-control input-inline input-100" value="">
            <label for="style">Style: </label>
            <select name="style" class="form-control select-inline">
                ${optionTemplates}
            </select>
        </td>
    </tr>
    
     <tr>
        <td class="fieldlabel"><b>Color</b></td>
        <td colspan="3" class="fieldarea">
        
            <label for="color_1">Name:</label>
            <input type="color" name="color_1" class="form-control input-inline input-50">
            
            <label for="color_2">Position:</label>
            <input type="color" name="color_2" class="form-control input-inline input-50">
            
            <label for="color_3">SM background:</label>
            <input type="color" name="color_3" class="form-control input-inline input-50">
                
            <label for="color_4">SM text:</label>
            <input type="color" name="color_4" class="form-control input-inline input-50">
            
            <label for="color_5">Bio text:</label>
            <input type="color" name="color_5" class="form-control input-inline input-50">
            
            <label for="color_6">Card background:</label>
            <input type="color" name="color_6" class="form-control input-inline input-50">
        </td>
    </tr>
    
    <tr>
        <td class="fieldlabel"><b>Background image/color</b></td>
        <td colspan="3" class="fieldarea"><input type="text" name="background_image" value="" class="form-control input-inline input-200">
        
        <input type="color" name="background_color" class="form-control input-inline input-50">
        <label class="checkbox-inline"><input type="checkbox" name="disable_background_shadow"><b>Disable Shadow</b></label>

        <label class="checkbox-inline"><input type="checkbox" name="disable_background_radius_top"><b>Disable Radius top</b></label>
        
        <label class="checkbox-inline"><input type="checkbox" name="disable_background_radius_bottom"><b>Disable Radius bottom</b></label>

        <label class="checkbox-inline"><input type="checkbox" name="disable_background"><b>Disable Background</b></label>     
        
        <label class="checkbox-inline"><input type="checkbox" name="full_width"><b>Full width</b></label>   
        </td>
    </tr>
   
       <tr>
        <td class="fieldlabel"><b>Header</b><br>e.g. (Our team)</td>
        <td colspan="3" class="fieldarea">
            <input type="text" name="header" value="" class="form-control input-inline input-200">
            <label for="header_text_color">Text color:</label>
            <input type="color" name="header_text_color" class="form-control input-inline input-50">       
            <label class="checkbox-inline">
            <input type="checkbox" name="disable_header"><b>Disable header</b></label>     
        </td>
    </tr>
    
    <tr>
        <td class="fieldlabel"><a type="button" name="add-row"><div style="font-size: 24px;" class="fa fa-plus"></div></a></td>
        <td colspan="3" class="fieldarea"></td>
    </tr>
    
    <tr>
        <td class="fieldlabel"></td>
        <td colspan="3" class="fieldarea">
            <table name="TeamSliderTable" class="datatable">
                <thead>
                <tr>
                    <th class="text-center" style="width: 405px;"><b>Name/IMG/Position/Bio</b></th>
                    <th class="text-center"><b>Social links</b></th>
                    <th class="text-center"></th>
                    <th class="text-center"></th>
                </tr>
                </thead>
                <tbody>
                </tbody>
            </table>
        </td>
    </tr>
    
    </tbody>
</table>
`);
        const table = render.querySelector("[name='TeamSliderTable']");
        const addRowButton = render.querySelector("[name='add-row']");

        const members = this.data && this.data.members ? this.data.members : "";
        const tbody = table.querySelector("tbody");
        Object.entries(members).forEach(([key, value]) => {
            const row = document.createElement("tr");

            row.innerHTML = `
                <td class="text-left" style="width: 405px;">
                
                    <label for="member_name">Name: </label>
                    <input type="text" name="member_name" value="${value.member_name}" class="form-control input-inline input-400"><br>
                    
                    <label for="member_img">IMG: </label>
                    <input type="text" name="member_img" value="${value.member_img}" class="form-control input-inline input-400"><br>
                    
                    <label for="member_position">Position: </label>
                    <input type="text" name="member_position" value="${value.member_position}" class="form-control input-inline input-400"><br>
                  
                    <label for="member_bio">Bio: </label>
                    <textarea name="member_bio" rows="4" class="form-control input-400" style="height: 85px; resize: none;">${value.member_bio}</textarea>
                </td>
                
                <td class="text-left">
                    <label for="member_linkedin">LinkedIn: </label>
                    <input type="text" name="member_linkedin" value="${value.member_linkedin}" class="form-control input-inline input-300"><br>
                    
                    <label for="member_facebook">Facebook: </label>
                    <input type="text" name="member_facebook" value="${value.member_facebook}" class="form-control input-inline input-300"><br>
                    
                    <label for="member_twitter">Twitter: </label>
                    <input type="text" name="member_twitter" value="${value.member_twitter}" class="form-control input-inline input-300"><br>
                    
                    <label for="member_instagram">Instagram: </label>
                    <input type="text" name="member_instagram" value="${value.member_instagram}" class="form-control input-inline input-300"><br>
                    
                    <label for="member_github">GitHub: </label>
                    <input type="text" name="member_github" value="${value.member_github}" class="form-control input-inline input-300"><br>
                  
                </td>

                <td class="text-center">
                  <a type="button" name="move-up" class="btn btn-warning"><div class="fa fa-arrow-up"></div></a>
                  <a type="button" name="move-down" class="btn btn-warning"><div class="fa fa-arrow-down"></div></a>
                </td>
                <td class="text-center"><a type="button" name="remove-row" class="btn btn-danger"><div class="fal fa-trash-alt"></div></a></td>
            `;
            tbody.appendChild(row);
            addRowListeners(row);
        });

        function addRow() {
            const tbody = table.querySelector("tbody");
            const row = document.createElement("tr");
            row.innerHTML = `
                <td class="text-left" style="width: 405px;">
                
                    <label for="member_name">Name: </label>
                    <input type="text" name="member_name" value="" class="form-control input-inline input-400"><br>
                    
                    <label for="member_img">IMG: </label>
                    <input type="text" name="member_img" value="" class="form-control input-inline input-400"><br>
                    
                    <label for="member_position">Position: </label>
                    <input type="text" name="member_position" value="" class="form-control input-inline input-400"><br>
                  
                    <label for="member_bio">Bio: </label>
                    <textarea name="member_bio" rows="4" class="form-control input-400" style="height: 85px; resize: none;"></textarea>
                </td>
                
                <td class="text-left">
                    <label for="member_linkedin">LinkedIn: </label>
                    <input type="text" name="member_linkedin" value="" class="form-control input-inline input-300"><br>
                    
                    <label for="member_facebook">Facebook: </label>
                    <input type="text" name="member_facebook" value="" class="form-control input-inline input-300"><br>
                    
                    <label for="member_twitter">Twitter: </label>
                    <input type="text" name="member_twitter" value="" class="form-control input-inline input-300"><br>
                    
                    <label for="member_instagram">Instagram: </label>
                    <input type="text" name="member_instagram" value="" class="form-control input-inline input-300"><br>
                    
                    <label for="member_github">GitHub: </label>
                    <input type="text" name="member_github" value="" class="form-control input-inline input-300"><br>
                  
                </td>
                
                <td class="text-center">
                  <a type="button" name="move-up" class="btn btn-warning"><div class="fa fa-arrow-up"></div></a>
                  <a type="button" name="move-down" class="btn btn-warning"><div class="fa fa-arrow-down"></div></a>
                </td>
                <td class="text-center"><a type="button" name="remove-row" class="btn btn-danger"><div class="fal fa-trash-alt"></div></a></td>
  `;
            tbody.appendChild(row);
            addRowListeners(row);
        }

        function removeRow(row) {
            row.remove();
        }

        function moveRow(row, direction) {
            const tbody = row.parentNode;
            const rows = Array.from(tbody.children);
            const index = rows.indexOf(row);
            const newIndex = index + direction;

            if (newIndex >= 0 && newIndex < rows.length) {
                const siblingRow = rows[newIndex];
                if (direction === 1) {
                    tbody.insertBefore(row, siblingRow.nextSibling);
                } else {
                    tbody.insertBefore(row, siblingRow);
                }
            } else if (newIndex === -1) {
                tbody.insertBefore(row, rows[0]);
            } else if (newIndex === rows.length) {
                tbody.insertBefore(row, null);
            }
        }

        function addRowListeners(row) {
            const removeButton = row.querySelector("[name='remove-row']");
            const moveUpButton = row.querySelector("[name='move-up']");
            const moveDownButton = row.querySelector("[name='move-down']");

            removeButton.addEventListener("click", () => {
                removeRow(row);
            });

            moveUpButton.addEventListener("click", () => {
                moveRow(row, -1);
            });

            moveDownButton.addEventListener("click", () => {
                moveRow(row, 1);
            });
        }

        addRowButton.addEventListener("click", () => {
            addRow();
        });

        const width = this.data && this.data.width ? this.data.width : "";
        $(render).find("[name='width']").val(width);

        const margin_top = this.data && this.data.margin_top ? this.data.margin_top : "";
        $(render).find("[name='margin_top']").val(margin_top);

        const margin_bottom = this.data && this.data.margin_bottom ? this.data.margin_bottom : "";
        $(render).find("[name='margin_bottom']").val(margin_bottom);

        const style = this.data && this.data.style ? this.data.style : "";
        $(render).find("[name='style']").val(style);
        if (style === '') {
            $(render).find("[name='style']").val('puq');
        }

        const color_1 = this.data && this.data.color_1 ? this.data.color_1 : "";
        $(render).find("[name='color_1']").val(color_1);
        if (color_1 === '') {
            $(render).find("[name='color_1']").val('#000000');
        }

        const color_2 = this.data && this.data.color_2 ? this.data.color_2 : "";
        $(render).find("[name='color_2']").val(color_2);
        if (color_2 === '') {
            $(render).find("[name='color_2']").val('#696969');
        }

        const color_3 = this.data && this.data.color_3 ? this.data.color_3 : "";
        $(render).find("[name='color_3']").val(color_3);
        if (color_3 === '') {
            $(render).find("[name='color_3']").val('#6420bf');
        }

        const color_4 = this.data && this.data.color_4 ? this.data.color_4 : "";
        $(render).find("[name='color_4']").val(color_4);
        if (color_4 === '') {
            $(render).find("[name='color_4']").val('#0de0b8');
        }

        const color_5 = this.data && this.data.color_5 ? this.data.color_5 : "";
        $(render).find("[name='color_5']").val(color_5);
        if (color_5 === '') {
            $(render).find("[name='color_5']").val('#000000');
        }

        const color_6 = this.data && this.data.color_6 ? this.data.color_6 : "";
        $(render).find("[name='color_6']").val(color_6);
        if (color_6 === '') {
            $(render).find("[name='color_6']").val('#ffffff');
        }

        const background_image = this.data && this.data.background_image ? this.data.background_image : "";
        $(render).find("[name='background_image']").val(background_image);

        const background_color = this.data && this.data.background_color ? this.data.background_color : "";
        $(render).find("[name='background_color']").val(background_color);
        if (background_color === '') {
            $(render).find("[name='background_color']").val('#ffffff');
        }

        if (this.data.disable_background_shadow === true) {
            $(render).find("[name='disable_background_shadow']").attr('checked', 'checked');
        }

        if (this.data.disable_background_radius_top === true) {
            $(render).find("[name='disable_background_radius_top']").attr('checked', 'checked');
        }

        if (this.data.disable_background_radius_bottom === true) {
            $(render).find("[name='disable_background_radius_bottom']").attr('checked', 'checked');
        }

        if (this.data.disable_background === true) {
            $(render).find("[name='disable_background']").attr('checked', 'checked');
        }

        if (this.data.full_width === true) {
            $(render).find("[name='full_width']").attr('checked', 'checked');
        }

        const header = this.data && this.data.header ? this.data.header : "";
        $(render).find("[name='header']").val(header);
        if (header === '') {
            $(render).find("[name='header']").val('Our team');
        }

        const header_text_color = this.data && this.data.header_text_color ? this.data.header_text_color : "";
        $(render).find("[name='header_text_color']").val(header_text_color);
        if (header_text_color === '') {
            $(render).find("[name='header_text_color']").val('#000000');
        }

        if (this.data.disable_header === true) {
            $(render).find("[name='disable_header']").attr('checked', 'checked');
        }

        function generateOptionTemplates(key) {
            const templates = JSON.parse(widgetsTemplatesJson);
            const lowerCaseKey = key.toLowerCase();
            if (lowerCaseKey in templates) {
                const templatesArray = templates[lowerCaseKey];
                let options = "";

                templatesArray.forEach((value) => {
                    options += '<option value="' + value + '">' + value + '</option>';
                });
                return options;
            }
            return "";
        }

        return render;
    }

    save(content) {

        var disable_background_shadow = false;
        if ($(content).find("[name='disable_background_shadow']").is(':checked')) {
            disable_background_shadow = true;
        }

        var disable_background_radius_top = false;
        if ($(content).find("[name='disable_background_radius_top']").is(':checked')) {
            disable_background_radius_top = true;
        }

        var disable_background_radius_bottom = false;
        if ($(content).find("[name='disable_background_radius_bottom']").is(':checked')) {
            disable_background_radius_bottom = true;
        }

        var disable_background = false;
        if ($(content).find("[name='disable_background']").is(':checked')) {
            disable_background = true;
        }

        var disable_header = false;
        if ($(content).find("[name='disable_header']").is(':checked')) {
            disable_header = true;
        }

        var full_width = false;
        if ($(content).find("[name='full_width']").is(':checked')) {
            full_width = true;
        }

        const table = content.querySelector("[name='TeamSliderTable']")
        const rows = table.querySelectorAll('tbody tr');
        const data = {};
        rows.forEach((row, index) => {
            const inputs = row.querySelectorAll('input');
            const textareas = row.querySelectorAll('textarea');

            const values = {};
            inputs.forEach(input => {
                const name = input.getAttribute('name');
                if (name === 'member_name') {
                    values[name] = input.value;
                }
                if (name === 'member_img') {
                    values[name] = input.value;
                }
                if (name === 'member_position') {
                    values[name] = input.value;
                }
                if (name === 'member_linkedin') {
                    values[name] = input.value;
                }
                if (name === 'member_facebook') {
                    values[name] = input.value;
                }
                if (name === 'member_twitter') {
                    values[name] = input.value;
                }
                if (name === 'member_instagram') {
                    values[name] = input.value;
                }
                if (name === 'member_github') {
                    values[name] = input.value;
                }
            });

            textareas.forEach(textarea => {
                const name = textarea.getAttribute('name');
                if (name === 'member_bio') {
                    values[name] = textarea.value;
                }
            });

            if (Object.keys(values).length > 0) {
                data[index] = values;
            }
        });

        return {
            "width": $(content).find("[name='width']").val().replace(/	/g, ""),
            "margin_top": $(content).find("[name='margin_top']").val().replace(/	/g, ""),
            "margin_bottom": $(content).find("[name='margin_bottom']").val().replace(/	/g, ""),
            "style": $(content).find("[name='style']").val().replace(/	/g, ""),

            "color_1": $(content).find("[name='color_1']").val().replace(/	/g, ""),
            "color_2": $(content).find("[name='color_2']").val().replace(/	/g, ""),
            "color_3": $(content).find("[name='color_3']").val().replace(/	/g, ""),
            "color_4": $(content).find("[name='color_4']").val().replace(/	/g, ""),
            "color_5": $(content).find("[name='color_5']").val().replace(/	/g, ""),
            "color_6": $(content).find("[name='color_6']").val().replace(/	/g, ""),

            "background_image": $(content).find("[name='background_image']").val().replace(/	/g, ""),
            "background_color": $(content).find("[name='background_color']").val().replace(/	/g, ""),
            "disable_background_shadow": disable_background_shadow,
            "disable_background_radius_top": disable_background_radius_top,
            "disable_background_radius_bottom": disable_background_radius_bottom,
            "disable_background": disable_background,
            "full_width": full_width,

            "header": $(content).find("[name='header']").val().replace(/	/g, ""),
            "header_text_color": $(content).find("[name='header_text_color']").val().replace(/	/g, ""),
            "disable_header": disable_header,

            "members": data
        };
    }
}

